﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;

namespace HeuristicLab.EvolutionaryTracking {
  public interface IVertex {
    string Id { get; }
    List<Arc> InEdges { get; }
    List<Arc> OutEdges { get; }
    int InDegree { get; }
    int OutDegree { get; }
    int Degree { get; }

    string Label { get; set; }
    double Weight { get; set; }

    IEnumerable<IVertex> Ancestors();
    IEnumerable<IVertex> Descendants();

    void AddForwardArc(IVertex target, double weight = 0.0, object content = null);
    void AddForwardArc(Arc arc);
    void AddReverseArc(IVertex target, double weight = 0.0, object content = null);
    void AddReverseArc(Arc arc);
  }
}
